(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     62148,       1493]
NotebookOptionsPosition[     60397,       1425]
NotebookOutlinePosition[     60746,       1440]
CellTagsIndexPosition[     60703,       1437]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["---Preamble", "Title",
 CellChangeTimes->{{3.7069489383059444`*^9, 3.7069489441945896`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"binDirectory", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<Bin\>\"", ",", 
     "\"\<hamiltonfastmarching\>\""}], "}"}], "]"}]}], "\n", 
 RowBox[{"libraryPath", "=", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{"binDirectory", ",", "\"\<libMathematicaHFM.dll\>\""}], "}"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.706953820581843*^9, 3.706953832373211*^9}, {
  3.706954044025282*^9, 3.706954044086445*^9}}],

Cell[BoxData["\<\"D:\\\\wrkLocal\\\\Projects\\\\_Exercises\\\\Bin\\\\\
hamiltonfastmarching\"\>"], "Output",
 CellChangeTimes->{{3.706954023500679*^9, 3.706954045650606*^9}},
 ImageSize->{397, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData["\<\"D:\\\\wrkLocal\\\\Projects\\\\_Exercises\\\\Bin\\\\\
hamiltonfastmarching\\\\libMathematicaHFM.dll\"\>"], "Output",
 CellChangeTimes->{{3.706954023500679*^9, 3.706954045653617*^9}},
 ImageSize->{551, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["---Functions", "Title",
 CellChangeTimes->{{3.7069539640384893`*^9, 3.7069539643583403`*^9}}],

Cell[CellGroupData[{

Cell["Hamilton fast marching via FileIO", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"--", 
      RowBox[{"--", 
       RowBox[{"--", 
        RowBox[{"--", " ", "Copied"}]}]}]}], " ", "from", " ", 
     RowBox[{"FileIO", ".", "nb"}]}], ",", " ", 
    RowBox[{"in", " ", 
     RowBox[{"JMMCPPLibs", "/", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Output", " ", "--"}], "--"}], "--"}], "--"}]}]}]}], "*)"}], 
  "\n", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"RulesToRaw", "[", 
      RowBox[{"l_List", ",", "fileName_String"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "\n", "\t", 
        RowBox[{
        "lStr", " ", ",", " ", "lNum", ",", " ", "lArr", ",", "\n", "\t", 
         RowBox[{"str", "=", "\"\<\>\""}], ",", 
         RowBox[{"data", "=", 
          RowBox[{"{", "}"}]}]}], "\n", "\t", "}"}], ",", "\n", "\t", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Length", "@", "#"}], "==", "2"}], "&"}], "/@", "l"}],
              ")"}]}]}], ",", "\n", "\t\t", 
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<SaveToFile Error : Elements of l are not pairs\>\"", "]"}], 
           ";", "\n", "\t\t", 
           RowBox[{"Return", "[", "True", "]"}], ";"}]}], "\n", "\t\t", "]"}],
         ";", "\n", "\t", "\n", "\t", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"StringQ", "@", 
                RowBox[{"First", "@", "#"}]}], "&"}], "/@", "l"}], ")"}]}]}], 
          ",", "\n", "\t\t", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<SaveToFile Error : Keys are not strings\>\"", 
            "]"}], ";", "\n", "\t\t", 
           RowBox[{"Return", "[", "True", "]"}], ";"}]}], "\n", "\t\t", "]"}],
         ";", "\n", "\t", "\n", "\t", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"StringQ", "@", "#"}], "||", 
                 RowBox[{"NumericQ", "@", "#"}], "||", 
                 RowBox[{"ArrayQ", "[", 
                  RowBox[{"#", ",", "_", ",", "NumericQ"}], "]"}], "||", 
                 RowBox[{"#", "===", "Null"}]}], ")"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{"Last", "/@", "l"}], ")"}]}], ")"}]}]}], ",", "\n", 
          "\t\t", 
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<SaveToFile Error : data format should be \
string|Numeric|Array\>\"", "]"}], ";", "\n", "\t\t", 
           RowBox[{"Return", "[", "True", "]"}], ";"}]}], "\n", "\t\t", "]"}],
         ";", "\n", "\t", "\n", "\t", 
        RowBox[{"lStr", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"l", ",", 
           RowBox[{
            RowBox[{"StringQ", "@", 
             RowBox[{"Last", "@", "#"}]}], "&"}]}], "]"}]}], ";", "\n", "\t", 
        RowBox[{"lNum", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"l", ",", 
           RowBox[{
            RowBox[{"NumericQ", "@", 
             RowBox[{"Last", "@", "#"}]}], "&"}]}], "]"}]}], ";", "\n", "\t", 
        RowBox[{"lArr", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"l", ",", 
           RowBox[{
            RowBox[{"ArrayQ", "@", 
             RowBox[{"Last", "@", "#"}]}], "&"}]}], "]"}]}], ";", "\n", "\t", 
        "\n", "\t", 
        RowBox[{"Do", "[", "\n", "\t\t", 
         RowBox[{
          RowBox[{
           RowBox[{"str", "=", 
            RowBox[{"str", "<>", 
             RowBox[{"(", 
              RowBox[{"First", "@", "eStr"}], ")"}], "<>", "\"\<\\n-1\\n\>\"",
              "<>", 
             RowBox[{"(", 
              RowBox[{"Last", "@", "eStr"}], ")"}], "<>", 
             "\"\<\\n\\n\>\""}]}], ";"}], "\n", "\t\t", ",", 
          RowBox[{"{", 
           RowBox[{"eStr", ",", "lStr"}], "}"}]}], "]"}], ";", "\n", "\t", 
        "\n", "\t", 
        RowBox[{"Do", "[", "\n", "\t\t", 
         RowBox[{
          RowBox[{
           RowBox[{"str", "=", 
            RowBox[{"str", "<>", 
             RowBox[{"(", 
              RowBox[{"First", "@", "eNum"}], ")"}], "<>", 
             "\"\<\\n0\\n\\n\>\""}]}], ";", "\n", "\t\t", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"data", ",", 
             RowBox[{"N", "@", 
              RowBox[{"Last", "@", "eNum"}]}]}], "]"}], ";"}], "\n", "\t\t", 
          ",", 
          RowBox[{"{", 
           RowBox[{"eNum", ",", "lNum"}], "}"}]}], "]"}], ";", "\n", "\t", 
        "\n", "\t", 
        RowBox[{"Do", "[", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{
           "Dimensions", " ", "are", " ", "reversed", " ", "because", " ", 
            "we", " ", "want", " ", "the", " ", "first", " ", "index", " ", 
            "to", " ", "be", " ", "the", " ", "fast", " ", "index"}], ",", 
           " ", 
           RowBox[{"like", " ", "Matlab"}], ",", " ", 
           RowBox[{"and", " ", "contrary", " ", "to", " ", "Mathematica"}]}], 
          "*)"}], "\n", "\t\t", 
         RowBox[{
          RowBox[{
           RowBox[{"With", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"dims", "=", 
               RowBox[{"Reverse", "@", 
                RowBox[{"Dimensions", "@", 
                 RowBox[{"Last", "@", "eArr"}]}]}]}], "}"}], ",", " ", "\n", 
             "\t\t\t", 
             RowBox[{
              RowBox[{"str", "=", 
               RowBox[{"str", "<>", 
                RowBox[{"(", 
                 RowBox[{"First", "@", "eArr"}], ")"}], "<>", "\"\<\\n\>\"", "<>", 
                RowBox[{"ToString", "[", 
                 RowBox[{"Length", "@", "dims"}], "]"}], "<>", 
                "\"\<\\n\>\""}]}], ";", "\n", "\t\t\t", 
              RowBox[{"Do", "[", 
               RowBox[{
                RowBox[{"str", "=", 
                 RowBox[{"str", "<>", 
                  RowBox[{"ToString", "[", "d", "]"}], "<>", 
                  "\"\<\\n\>\""}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"d", ",", "dims"}], "}"}]}], "]"}], ";", "\n", 
              "\t\t\t", 
              RowBox[{"str", "=", 
               RowBox[{"str", "<>", "\"\<\\n\>\""}]}], ";"}]}], "\n", 
            "\t\t\t", "]"}], ";", "\n", "\t\t", 
           RowBox[{"data", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"data", ",", 
              RowBox[{"N", "@", 
               RowBox[{"Flatten", "@", 
                RowBox[{"Last", "@", "eArr"}]}]}]}], "]"}]}], ";"}], "\n", 
          "\t\t", ",", 
          RowBox[{"{", 
           RowBox[{"eArr", ",", "lArr"}], "}"}]}], "]"}], ";", "\n", "\t", 
        "\n", "\t", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"StringLength", "[", "fileName", "]"}], ">", "0"}], ",", 
          "\n", "\t\t", 
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"formatFile", "=", 
               RowBox[{"fileName", "<>", "\"\<_Format.txt\>\""}]}], ",", 
              RowBox[{"dataFile", "=", 
               RowBox[{"fileName", "<>", "\"\<_Data.dat\>\""}]}]}], "}"}], 
            ",", "\n", "\t\t\t", 
            RowBox[{
             RowBox[{"Export", "[", 
              RowBox[{"formatFile", ",", "str"}], "]"}], ";", " ", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"Mathematica", " ", "adds", " ", "one", " ", "\\n"}], 
               ",", " ", 
               RowBox[{
                RowBox[{
                "so", " ", "we", " ", "must", " ", "remove", " ", "one"}], 
                "..."}]}], "*)"}], "\n", "\t\t\t", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "@", "data"}], ">", "0"}], ",", 
               RowBox[{
                RowBox[{"BinaryWrite", "[", 
                 RowBox[{"dataFile", ",", "data", ",", "\"\<Real64\>\""}], 
                 "]"}], ";", " ", 
                RowBox[{"Close", "[", "dataFile", "]"}], ";"}]}], "]"}], ";", 
             "\n", "\t\t\t", 
             RowBox[{"Return", "[", "False", "]"}], ";"}]}], "\n", "\t\t", 
           "]"}], ",", "\n", "\t\t", 
          RowBox[{
           RowBox[{"Return", "[", 
            RowBox[{"{", 
             RowBox[{"str", ",", "data"}], "}"}], "]"}], ";"}]}], "\n", 
         "\t\t", "]"}], ";"}]}], "\n", "\t", "]"}]}], ";"}], "\n", "\t", "\n", 
   RowBox[{
    RowBox[{"RawToRules", "[", "fileName_String", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"formatFile", "=", 
         RowBox[{"fileName", "<>", "\"\<_Format.txt\>\""}]}], ",", 
        RowBox[{"dataFile", "=", 
         RowBox[{"fileName", "<>", "\"\<_Data.dat\>\""}]}], ",", "data"}], 
       "}"}], ",", "\n", "\t", 
      RowBox[{"RawToRules", "[", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{"formatFile", ",", "\"\<String\>\""}], "]"}], ",", 
        RowBox[{"BinaryReadList", "[", 
         RowBox[{"dataFile", ",", "\"\<Real64\>\""}], "]"}]}], "]"}]}], "\n", 
     "\t", "]"}]}], "\n", "\n", 
   RowBox[{
    RowBox[{"RawToRules", "[", 
     RowBox[{"str_String", ",", "data_List"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"l", "=", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"pos", "=", "0"}], ",", 
        RowBox[{"newlineCharacter", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"$OperatingSystem", "==", "\"\<Windows\>\""}], ",", 
           "\"\<\\r\\n\>\"", ",", "\"\<\\n\>\""}], "]"}]}]}], "}"}], ",", 
      "\n", "\t", 
      RowBox[{
       RowBox[{"Do", "[", "\n", "\t\t", 
        RowBox[{
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"format", " ", "=", " ", 
              RowBox[{"StringSplit", "[", 
               RowBox[{"s", ",", "newlineCharacter"}], "]"}]}], ",", "dim", 
             ",", "dims", ",", 
             RowBox[{"oldPos", "=", "pos"}], ",", 
             RowBox[{"oldLen", "=", 
              RowBox[{"Length", "@", "l"}]}]}], "}"}], ",", "\n", "\t\t\t", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "@", "format"}], ">=", "2"}], ",", "\n", 
              "\t\t\t\t", 
              RowBox[{
               RowBox[{"dim", "=", 
                RowBox[{"ToExpression", "[", 
                 RowBox[{"format", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ";", "\n", 
               "\t\t\t\t", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"IntegerQ", "[", "dim", "]"}], " ", "&&", " ", 
                  RowBox[{"dim", ">=", 
                   RowBox[{"-", "1"}]}]}], ",", "\n", "\t\t\t\t\t", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"dim", "==", 
                    RowBox[{"-", "1"}]}], ",", "\n", "\t\t\t\t\t\t", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "@", "format"}], "==", "3"}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"l", ",", 
                    RowBox[{
                    RowBox[{"format", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "->", 
                    RowBox[{"format", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], " ", "]"}]}], "]"}], 
                   ",", "\n", "\t\t\t\t\t\t", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "@", "format"}], "==", 
                    RowBox[{"dim", "+", "2"}]}], ",", "\n", "\t\t\t\t\t\t\t", 
                    RowBox[{
                    RowBox[{"dims", "=", 
                    RowBox[{"Reverse", "@", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"ToExpression", "@", 
                    RowBox[{"format", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}]}], ";", "\n", 
                    "\t\t\t\t\t\t\t", 
                    RowBox[{"pos", "=", 
                    RowBox[{"pos", "+", 
                    RowBox[{"Times", "@@", "dims"}]}]}], ";", "\n", 
                    "\t\t\t\t\t\t\t", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Length", "@", "data"}], ">=", "pos"}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"l", ",", 
                    RowBox[{
                    RowBox[{"format", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "->", " ", 
                    RowBox[{"ArrayReshape", "[", 
                    RowBox[{
                    RowBox[{"data", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"oldPos", "+", "1"}], ";;", "pos"}], "]"}], "]"}],
                     ",", "dims"}], "]"}]}]}], " ", "]"}]}], "]"}]}]}], "\n", 
                    "\t\t\t\t\t\t\t", "]"}]}], "\n", "\t\t\t\t\t\t", "]"}]}], 
                "\n", "\t\t\t\t\t", "]"}]}]}], "\n", "\t\t\t\t", "]"}], ";", 
            "\n", "\t\t\t", 
            RowBox[{"(*", 
             RowBox[{
             "Allow", " ", "for", " ", "a", " ", "final", " ", "blank", " ", 
              "line"}], "*)"}], "\n", "\t\t\t", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Length", "@", "l"}], "==", "oldLen"}], " ", "&&", 
               " ", 
               RowBox[{"s", "!=", "newlineCharacter"}]}], ",", 
              RowBox[{"Print", "[", 
               RowBox[{
               "\"\<RawToRules error : could not import \>\"", "<>", "s"}], 
               "]"}]}], "]"}], ";"}]}], "\n", "\t\t\t", "]"}], "\n", "\t\t", 
         ",", 
         RowBox[{"{", 
          RowBox[{"s", ",", 
           RowBox[{"StringSplit", "[", 
            RowBox[{"str", ",", 
             RowBox[{"newlineCharacter", "<>", "newlineCharacter"}]}], 
            "]"}]}], "}"}]}], "]"}], ";", "\n", "\t", "l"}]}], "\n", "\t", 
     "]"}]}]}]}]], "Input"],

Cell[BoxData[""], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hamilton fast marching via Wolfram Library Link", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
      "**", "**", "**", "**", "**", "**", "**", "**", "Load"}], " ", "HFM", 
    " ", "wolfram", " ", "library", " ", "link", " ", 
    RowBox[{"functions", ":"}]}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"LoadHFMWLL", "[", "lfmwllLibraryFile_", "]"}], ":=", 
    RowBox[{"Module", "[", "\n", "\t", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"**", "**", "**", "**", "**", "The"}], " ", "main", " ", 
        RowBox[{"functions", ":"}]}], "*)"}], "\n", "\t", 
      RowBox[{
       RowBox[{"hfmRunModel", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", " ", "\"\<RunModel\>\"", ",", " ", 
          RowBox[{"{", "}"}], ",", " ", "Real"}], "]"}]}], ";", "\n", 
       "\t\t\t\t", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**", "**", "**", "**", "Get"}], " ", 
         RowBox[{"functions", ":"}]}], "*)"}], "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "GetScalar"}], "*)"}], "\n", "\t", 
       RowBox[{"hfmGetScalar", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", " ", "\"\<GetScalar\>\"", ",", " ", 
          RowBox[{"{", "String", 
           RowBox[{"(*", "key", "*)"}], "}"}], ",", " ", "Real"}], 
         RowBox[{"(*", "keyval", "*)"}], "]"}]}], ";", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "GetString"}], "*)"}], "\n", "\t", 
       RowBox[{"hfmGetString", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", "\"\<GetString\>\"", ",", " ", 
          RowBox[{"{", "String", 
           RowBox[{"(*", "key", "*)"}], "}"}], ",", " ", "String"}], 
         RowBox[{"(*", "keyval", "*)"}], "]"}]}], ";", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "GetVector"}], "*)"}], "\n", "\t", 
       RowBox[{"hfmGetVector", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", "\"\<GetVector\>\"", ",", " ", 
          RowBox[{"{", "String", 
           RowBox[{"(*", "key", "*)"}], "}"}], ",", " ", 
          RowBox[{"{", 
           RowBox[{"Real", ",", "1"}], "}"}]}], 
         RowBox[{"(*", "keyval", "*)"}], "]"}]}], ";", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "GetArray"}], "*)"}], "\n", "\t", 
       RowBox[{"Quiet", "@", 
        RowBox[{"Do", "[", 
         RowBox[{"(*", 
          RowBox[{"Quiet", " ", "overload", " ", "messages"}], "*)"}], "\n", 
         "\t\t\t", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"hfmGetArrayBase", "[", "d", "]"}], " ", "=", " ", 
            RowBox[{"LibraryFunctionLoad", "[", 
             RowBox[{
             "lfmwllLibraryFile", ",", " ", "\"\<GetArray\>\"", ",", " ", 
              RowBox[{"{", 
               RowBox[{"String", 
                RowBox[{"(*", "key", "*)"}], ",", " ", "Integer"}], 
               RowBox[{"(*", "Dimension", "*)"}], "}"}], ",", " ", 
              RowBox[{"{", 
               RowBox[{"Real", ",", "d"}], "}"}]}], 
             RowBox[{"(*", "keyval", "*)"}], "]"}]}], ";"}], "\n", "\t\t\t", 
          ",", 
          RowBox[{"{", 
           RowBox[{"d", ",", "1", ",", "6", ",", "1"}], "}"}]}], "]"}]}], ";",
        "\n", "\t", 
       RowBox[{
        RowBox[{
         RowBox[{"hfmGetArray", "[", "d_", "]"}], "[", "key_", "]"}], ":=", 
        RowBox[{
         RowBox[{"hfmGetArrayBase", "[", "d", "]"}], "[", 
         RowBox[{"key", ",", "d"}], "]"}]}], ";", "\n", "\t\t", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**", "**", "**", "**", "Set"}], " ", 
         RowBox[{"functions", ":"}]}], "*)"}], "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "SetScalar"}], "*)"}], "\n", "\t", 
       RowBox[{"hfmSetScalar", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", " ", "\"\<SetScalar\>\"", ",", " ", 
          RowBox[{"{", 
           RowBox[{"String", 
            RowBox[{"(*", "key", "*)"}], ",", " ", "Real"}], 
           RowBox[{"(*", "val", "*)"}], "}"}], ",", " ", "\"\<Void\>\""}], 
         "]"}]}], ";", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "SetString"}], "*)"}], "\n", "\t", 
       RowBox[{"hfmSetString", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", " ", "\"\<SetString\>\"", ",", " ", 
          RowBox[{"{", 
           RowBox[{"String", 
            RowBox[{"(*", "key", "*)"}], ",", " ", "String"}], 
           RowBox[{"(*", "val", "*)"}], "}"}], ",", " ", "\"\<Void\>\""}], 
         "]"}]}], ";", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "SetVector"}], "*)"}], "\n", "\t", 
       RowBox[{"hfmSetVector", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", " ", "\"\<SetVector\>\"", ",", " ", 
          RowBox[{"{", 
           RowBox[{"String", 
            RowBox[{"(*", "key", "*)"}], ",", " ", 
            RowBox[{"{", 
             RowBox[{"Real", ",", "1"}], "}"}]}], 
           RowBox[{"(*", "val", "*)"}], "}"}], ",", " ", "\"\<Void\>\""}], 
         "]"}]}], ";", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"**", "**"}], "*", "SetArray"}], "*)"}], "\n", "\t", 
       RowBox[{"Quiet", "@", 
        RowBox[{"Do", "[", "\n", "\t\t\t", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"hfmSetArray", "[", "d", "]"}], " ", "=", " ", 
            RowBox[{"LibraryFunctionLoad", "[", 
             RowBox[{
             "lfmwllLibraryFile", ",", " ", "\"\<SetArray\>\"", ",", " ", 
              RowBox[{"{", 
               RowBox[{"String", 
                RowBox[{"(*", "key", "*)"}], ",", " ", 
                RowBox[{"{", 
                 RowBox[{"Real", ",", "d"}], "}"}]}], 
               RowBox[{"(*", 
                RowBox[{"val", " ", 
                 RowBox[{"(", 
                  RowBox[{"d", "-", 
                   RowBox[{"dimensional", " ", "array"}]}], ")"}]}], "*)"}], 
               "}"}], ",", " ", "\"\<Void\>\""}], "]"}]}], ";"}], "\n", 
          "\t\t\t", ",", 
          RowBox[{"{", 
           RowBox[{"d", ",", "1", ",", "6", ",", "1"}], "}"}]}], "]"}]}], ";",
        "\n", "\t\t\t", "\n", "\t", 
       RowBox[{"(*", 
        RowBox[{"**", "**", "**", "**", "**", 
         RowBox[{"HasField", ":"}]}], "*)"}], "\n", "\t", 
       RowBox[{"hfmHasField", " ", "=", " ", 
        RowBox[{"LibraryFunctionLoad", "[", 
         RowBox[{"lfmwllLibraryFile", ",", "\"\<HasField\>\"", ",", " ", 
          RowBox[{"{", "String", 
           RowBox[{"(*", "key", "*)"}], "}"}], ",", " ", 
          RowBox[{"True", "|", "False"}]}], 
         RowBox[{"(*", "keyval", "*)"}], "]"}]}], ";", "\n", "\t\t\t", "\n", 
       "\t", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"**", "**", "**", "**", "**", "Additional"}], " ", 
          "front"}], "-", 
         RowBox[{"end", " ", 
          RowBox[{"functions", ":"}]}]}], "*)"}], "\n", "\t", 
       RowBox[{
        RowBox[{"hfmSetVariable", "[", 
         RowBox[{"key_", ",", "val_"}], "]"}], ":=", 
        RowBox[{"Switch", "[", " ", 
         RowBox[{
          RowBox[{"Head", "[", "val", "]"}], "\n", "\t\t", ",", "String", ",",
           "\n", "\t\t\t", 
          RowBox[{"hfmSetString", "[", 
           RowBox[{"key", ",", "val"}], "]"}], "\n", "\t\t", ",", "Integer", 
          ",", "\n", "\t\t\t", 
          RowBox[{"hfmSetScalar", "[", 
           RowBox[{"key", ",", "val"}], "]"}], "\n", "\t\t", ",", "Real", ",",
           "\n", "\t\t\t", 
          RowBox[{"hfmSetScalar", "[", 
           RowBox[{"key", ",", "val"}], "]"}], "\n", "\t\t", ",", "List", ",",
           "\n", "\t\t\t", 
          RowBox[{
           RowBox[{"hfmSetArray", "[", 
            RowBox[{"TensorRank", "[", "val", "]"}], "]"}], "[", 
           RowBox[{"key", ",", "val"}], "]"}]}], "\n", "\t\t", "]"}]}], 
       ";"}]}], 
     RowBox[{"(*", 
      RowBox[{"end", " ", "of", " ", "switch"}], "*)"}], "\n", "]"}]}], "\n", 
   "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
     "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
       "**", "**", "**", "**", "**", "**", "**", "**", "Unload"}], " ", "HFM",
      " ", "wolfram", " ", "library", " ", 
     RowBox[{"link", ":"}]}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"UnloadHFMWLL", "[", "]"}], ":=", 
    RowBox[{"Module", "[", "\n", "\t", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\n", "\t", 
      RowBox[{"(*", 
       RowBox[{"The", " ", "main", " ", "functions"}], "*)"}], "\n", "\t", 
      RowBox[{
       RowBox[{"LibraryFunctionUnload", "[", "hfmRunModel", "]"}], ";", "\n", 
       "\t", 
       RowBox[{"(*", 
        RowBox[{"Get", " ", "functions"}], "*)"}], "\n", "\t", 
       RowBox[{"LibraryFunctionUnload", "[", "hfmGetScalar", "]"}], ";", "\n",
        "\t", 
       RowBox[{"LibraryFunctionUnload", "[", "hfmGetString", "]"}], ";", "\n",
        "\t", 
       RowBox[{"LibraryFunctionUnload", "[", "hfmGetVector", "]"}], ";", "\n",
        "\t", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"LibraryFunctionUnload", "[", 
           RowBox[{"hfmGetArrayBase", "[", "d", "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"d", ",", "1", ",", "6", ",", "1"}], "}"}]}], "]"}], "\n", 
        "\t", 
        RowBox[{"(*", 
         RowBox[{"Set", " ", "functions"}], "*)"}], "\n", "\t", 
        RowBox[{"LibraryFunctionUnload", "[", "hfmSetScalar", "]"}]}], ";", 
       "\n", "\t", 
       RowBox[{"LibraryFunctionUnload", "[", "hfmSetString", "]"}], ";", "\n",
        "\t", 
       RowBox[{"LibraryFunctionUnload", "[", "hfmSetVector", "]"}], ";", "\n",
        "\t", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"LibraryFunctionUnload", "[", 
          RowBox[{"hfmSetArray", "[", "d", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"d", ",", "1", ",", "6", ",", "1"}], "}"}]}], "]"}], ";", 
       "\n", "\t", 
       RowBox[{"(*", "HasField", "*)"}], "\n", "\t", 
       RowBox[{"LibraryFunctionUnload", "[", "hfmHasField", "]"}], ";"}]}], 
     "\n", "]"}]}]}]}]], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["---Sub-Riemannian Wavefront propagation (fast marching)", "Title",
 CellChangeTimes->{{3.706953992870192*^9, 3.7069539980058546`*^9}}],

Cell[CellGroupData[{

Cell["Via Library Link", "Section"],

Cell[CellGroupData[{

Cell["\<\
Domain specification, point on the circle are specified with angles \[Theta] \
from 0 to \[Pi] or 0 to 2\[Pi] with N\[Theta] number of samples\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["Specify volume dimensions and sampling", "Subsubsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Spatial", " ", "dimensions"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"xyMinMax", "=", "4"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Physical", " ", "spatial", " ", "range"}], ",", " ", 
      RowBox[{
       RowBox[{"volume", " ", "runs", " ", "from"}], " ", "-", 
       RowBox[{"xyMinMax", " ", "to"}], " ", "+", "xyMinMax"}]}], "*)"}], 
    "\n", 
    RowBox[{"gridScale", "=", "0.1"}], ";", 
    RowBox[{"(*", 
     RowBox[{"In", " ", "steps", " ", "of", " ", "\"\<gridScale\>\"", " ", 
      RowBox[{"(", 
       RowBox[{"smaller", " ", "means", " ", "more", " ", "detail"}], ")"}]}],
      "*)"}], "\n", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Nx", ",", "Ny"}], "}"}], "=", 
     RowBox[{"Round", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "*", 
          RowBox[{"xyMinMax", "/", "gridScale"}]}], "+", "1"}], ",", 
        RowBox[{
         RowBox[{"2", "*", 
          RowBox[{"xyMinMax", "/", "gridScale"}]}], "+", "1"}]}], "}"}]}]}], 
    ";"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{"Orientation", " ", 
     RowBox[{"sampling", ":"}]}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"projective", "=", "False"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"N\[Theta]", "=", "64"}], ";"}]}]}]], "Input",
 CellChangeTimes->{3.70695387621585*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
1. make library link
2. set parameters (Check xyMinMax (the physical spatial range) and \
\"gridScale\" (smaller means more detail))
3. run code
4. get results
5. close library link
6. reformat the data\
\>", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"**", "**", "**", "**"}], "*", "1.", " ", "Load", " ", "hfm", " ",
     "library", " ", "link", " ", "functions"}], "*)"}], "\n", 
  RowBox[{
   RowBox[{
    RowBox[{"LoadHFMWLL", "[", "libraryPath", "]"}], ";"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"**", "**", "**", "**"}], "*", "2.", " ", "Set", " ", 
     "parameters"}], "*)"}], "\n", 
   RowBox[{"(*", 
    RowBox[{"First", " ", "specify", " ", "them"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"prms", "=", 
     RowBox[{"Association", "[", 
      RowBox[{"{", "}"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<model\>\"", "]"}], "        ", "=", " ", 
     "\"\<ReedsShepp2\>\""}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<projective\>\"", "]"}], "   ", "=", " ", 
     RowBox[{"If", "[", 
      RowBox[{"projective", ",", "1.", ",", "0."}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<xi\>\"", "]"}], "           ", "=", " ", 
     "1."}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<eps\>\"", "]"}], "          ", "=", " ", 
     "0.1"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<gridScale\>\"", "]"}], "    ", "=", " ", 
     "gridScale"}], ";", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Means", " ", "that", " ", "the", " ", "physical", " ", "x"}], 
      "-", 
      RowBox[{"range", " ", "is", " ", "Nx", "*", "gridScale"}]}], "*)"}], 
    "\n", 
    RowBox[{
     RowBox[{"prms", "[", "\"\<dims\>\"", "]"}], "         ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"Nx", ",", "Ny", ",", "N\[Theta]"}], "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<speed\>\"", "]"}], "        ", "=", " ", 
     RowBox[{"ConstantArray", "[", 
      RowBox[{"1.", ",", 
       RowBox[{"{", 
        RowBox[{"Nx", ",", "Ny", ",", "N\[Theta]"}], "}"}]}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<origin\>\"", "]"}], "       ", "=", " ", 
     RowBox[{"-", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"gridScale", "*", 
         RowBox[{"Nx", "/", "2"}]}], ",", 
        RowBox[{"gridScale", "*", 
         RowBox[{"Ny", "/", "2"}]}]}], "}"}]}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<seeds\>\"", "]"}], "        ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0.", ",", "0.", ",", "0."}], "}"}], "}"}]}], ";", 
    RowBox[{"(*", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "\[Theta]"}], "}"}], "*)"}], "\n", 
    RowBox[{
     RowBox[{"prms", "[", "\"\<tips\>\"", "]"}], "         ", "=", " ", 
     RowBox[{"{", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"8.", ",", "5.", ",", 
          RowBox[{"\[Pi]", "/", "3."}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"8.", ",", 
          RowBox[{"-", "4"}], ",", "0"}], "}"}]}], "*)"}], 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2.5", ",", "2.5", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}], "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", 
             RowBox[{"\[Pi]", "/", "N\[Theta]"}]}], ")"}], "/", "2"}]}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.5", ",", "2.5", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[Pi]"}], "/", "2"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", 
             RowBox[{"\[Pi]", "/", "N\[Theta]"}]}], ")"}], "/", "4"}]}]}], 
        "}"}]}], "}"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"prms", "[", "\"\<exportValues\>\"", "]"}], " ", "=", " ", 
     "1."}], ";"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{"Then", " ", "set"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"hfmSetVariable", "[", 
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"#", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "&"}], "/@", 
      RowBox[{"Normal", "[", "prms", "]"}]}], ";"}], "//", "AbsoluteTiming"}],
    "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"**", "**", "**", "**"}], "*", "3.", " ", "Run", " ", "the", " ",
      "code"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"output", "=", 
      RowBox[{"hfmRunModel", "[", "]"}]}], ";"}], "//", "AbsoluteTiming"}], 
   "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"**", "**", "**", "**"}], "*", "4.", " ", "Get", " ", "the", " ",
      "data", " ", "to", " ", "Mathematica"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"values", "=", 
     RowBox[{
      RowBox[{"hfmGetArray", "[", "3", "]"}], "[", "\"\<values\>\"", "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{"geodesicsAll", "=", 
     RowBox[{
      RowBox[{"hfmGetArray", "[", "2", "]"}], "[", "\"\<geodesicPoints\>\"", 
      "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"endIndices", "=", 
     RowBox[{"Round", "@", 
      RowBox[{"Accumulate", "[", 
       RowBox[{
        RowBox[{"hfmGetArray", "[", "1", "]"}], "[", 
        "\"\<geodesicLengths\>\"", "]"}], "]"}]}]}], ";"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"**", "**", "**", "**"}], "*", "5.", " ", "Close", " ", "the", 
     " ", "library", " ", "link"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"UnloadHFMWLL", "[", "]"}], ";"}], "\n", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"**", "**", "**", "**"}], "*", "6.", " ", "Reformat", " ", "the",
      " ", "data"}], "*)"}], "\n", 
   RowBox[{
    RowBox[{"startIndices", "=", 
     RowBox[{
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"endIndices", "+", "1"}], ",", "1"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", 
        RowBox[{"-", "2"}]}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"geodesics", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"geodesicsAll", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"startIndices", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ";;", 
          RowBox[{"endIndices", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "[", "startIndices", "]"}], ",", "1"}], "}"}]}], 
      "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.7069540177092733`*^9, 3.7069540182166224`*^9}, {
  3.706954063929234*^9, 3.706954150488513*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.008167117564142273`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.7069540237583647`*^9, 3.706954049558001*^9}, {
  3.706954087708503*^9, 3.7069541506108437`*^9}},
 ImageSize->{129, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.971754249287308`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.7069540237583647`*^9, 3.706954049558001*^9}, {
  3.706954087708503*^9, 3.7069541515804205`*^9}},
 ImageSize->{115, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Show results", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resultsLFM", "=", 
  RowBox[{"Show", "[", "\n", "\t", 
   RowBox[{
    RowBox[{"ImageAdjust", "[", 
     RowBox[{"Image", "[", 
      RowBox[{"Map", "[", 
       RowBox[{"Min", ",", "values", ",", 
        RowBox[{"{", "2", "}"}]}], "]"}], "]"}], "]"}], ",", "\n", "\t", 
    RowBox[{"Table", "[", "\n", "\t\t", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"{", 
        RowBox[{"Orange", ",", "Thick", ",", 
         RowBox[{"Line", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "-", 
                 RowBox[{
                  RowBox[{"prms", "[", "\"\<origin\>\"", "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "/", 
               RowBox[{"prms", "[", "\"\<gridScale\>\"", "]"}]}], ",", 
              RowBox[{"Nx", "-", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "-", 
                  RowBox[{
                   RowBox[{"prms", "[", "\"\<origin\>\"", "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
                RowBox[{"prms", "[", "\"\<gridScale\>\"", "]"}]}]}]}], "}"}], 
            "&"}], "/@", 
           RowBox[{"geodesics", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "}"}], "]"}], "\n", 
      "\t\t", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "[", "geodesics", "]"}], ",", "1"}], "}"}]}], "]"}],
     ",", "\n", "\t", 
    RowBox[{"ImageSize", "->", "400"}], ",", 
    RowBox[{"Frame", "->", "False"}], ",", 
    RowBox[{"Framed", "->", "True"}]}], "]"}]}]], "Input"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3Qm8XeO5x3FK76W0orRVYtaKKSGhQQhBDDFFEiQRJJIg8zyenJyTQWZD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    "], {{0, 400}, {400, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{400, 400},
  PlotRange->{{0, 400}, {0, 400}}]], "Output",
 CellChangeTimes->{{3.7069540239147825`*^9, 3.706954049703394*^9}, {
  3.706954090084819*^9, 3.7069541526673098`*^9}},
 ImageSize->{404, 400},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["---End of notebook", "Title",
 CellChangeTimes->{{3.706953695204878*^9, 3.7069536983412037`*^9}}],

Cell[CellGroupData[{

Cell["Convert output to bitmap to reduce notebook size", "Section",
 CellChangeTimes->{{3.631265495696987*^9, 3.6312654995601997`*^9}, {
  3.706939152123087*^9, 3.706939156026475*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Run", " ", "to", " ", "convert", " ", "all", " ", "image", " ", "output", 
    " ", "to", " ", "bitmap"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookFind", "[", 
     RowBox[{
      RowBox[{"InputNotebook", "[", "]"}], ",", "\"\<Output\>\"", ",", "All", 
      ",", "CellStyle"}], "]"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"FrontEndTokenExecute", "[", 
     RowBox[{
      RowBox[{"InputNotebook", "[", "]"}], ",", "\"\<SelectionConvert\>\"", 
      ",", "\"\<BitmapConditional\>\""}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.615614680193201*^9, 3.615614720877468*^9}},
 CellID->133026008]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1920, 1117},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 98, 1, 101, "Title"],
Cell[CellGroupData[{
Cell[703, 27, 534, 13, 50, "Input"],
Cell[1240, 42, 262, 5, 30, "Output"],
Cell[1505, 49, 287, 5, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1841, 60, 99, 1, 101, "Title"],
Cell[CellGroupData[{
Cell[1965, 65, 52, 0, 70, "Section"],
Cell[2020, 67, 14906, 374, 1498, "Input"],
Cell[16929, 443, 26, 0, 30, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[16992, 448, 66, 0, 56, "Section"],
Cell[17061, 450, 10699, 248, 1248, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27809, 704, 140, 1, 101, "Title"],
Cell[CellGroupData[{
Cell[27974, 709, 35, 0, 70, "Section"],
Cell[CellGroupData[{
Cell[28034, 713, 172, 3, 49, "Subsection"],
Cell[CellGroupData[{
Cell[28231, 720, 63, 0, 39, "Subsubsection"],
Cell[28297, 722, 1374, 40, 164, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29720, 768, 232, 8, 199, "Subsection"],
Cell[CellGroupData[{
Cell[29977, 780, 6594, 192, 677, "Input"],
Cell[36574, 974, 303, 7, 30, "Output"],
Cell[36880, 983, 300, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37217, 995, 37, 0, 39, "Subsubsection"],
Cell[CellGroupData[{
Cell[37279, 999, 1887, 48, 126, "Input"],
Cell[39169, 1049, 20107, 336, 415, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[59361, 1394, 103, 1, 101, "Title"],
Cell[CellGroupData[{
Cell[59489, 1399, 184, 2, 70, "Section"],
Cell[59676, 1403, 693, 18, 69, "Input",
 CellID->133026008]
}, Open  ]]
}, Open  ]]
}
]
*)

